import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Interface que o cliente deve implementar. O cliente tambem eh remote, deta maneira os servidores tem
 * como contacata-los apos alguma mudanca em outro cliente.
 * 
 */
public interface Client extends Remote {
	/**
	 * Este metodo eh chamado pelo servidor slave, para notificar este cliente, de que o cliente C
	 * mexeu na setinha
	 */
	void avisa(Setinha s) throws RemoteException;
	
	/**
	 * Devolve o ID desse cliente, apenas para distincao
	 */
	String getId() throws RemoteException;
	
	/**
	 * Retorna a setinha deste cliente, para que ela possa ser renderizada
	 */
	Setinha getSetinha() throws RemoteException;

    //este metodo o cliente chama pra se desconectar do servidor 
	void exit() throws RemoteException;
}
