import javax.swing.*;
import java.awt.*;
import java.rmi.*;
import java.awt.event.*;
import java.util.*;

/**
 * Classe auxiliar para o desenho da canvas e setinhas.
 * 
 */
public class Janela extends JFrame implements KeyListener {

	private Canvas canvas;
	private final ClientImpl client;

	public void keyPressed(KeyEvent e) {
		try {

			Setinha s = client.getSetinha();
			SetinhaCopia sc = client.getMinhaSetinha();
			float rad = (float) (((float) s.getAngle() * Math.PI) / 180);

			int nx, ny, na;
			
			nx = s.getX();
			ny = s.getY();
			na = s.getAngle();

			// subindo
			if (e.getKeyCode() == e.VK_UP) {

				nx = nx + (int) ( 6 * Math.cos(rad));
				ny = ny - (int) ( 6 * Math.sin(rad));
	
				//s.setX(s.getX() + (int) (6 * Math.cos(rad)));
				//s.setY(s.getY() - (int) (6 * Math.sin(rad)));					
				//client.slave.notifyMasterServer(s);
			}

			if (e.getKeyCode() == e.VK_DOWN) {

				nx = nx - (int) ( 6 * Math.cos(rad));
				ny = ny + (int) ( 6 * Math.sin(rad));
	

				//s.setX(s.getX() - (int) (6 * Math.cos(rad)));
				//s.setY(s.getY() + (int) (6 * Math.sin(rad)));
				//client.slave.notifyMasterServer(s);
			}

			if (e.getKeyCode() == e.VK_LEFT) {

				na += 4;

				//s.setAngle(s.getAngle() + 4);
				//client.slave.notifyMasterServer(s);
			}

			if (e.getKeyCode() == e.VK_RIGHT) {

				na -= 4;

				//s.setAngle(s.getAngle() - 4);
				//client.slave.notifyMasterServer(s);
			}
			
			s.setX(nx);
			s.setY(ny);
			s.setAngle(na);
			sc.x = nx;
			sc.y = ny;
			sc.angle = na;
			client.slave.notifyMasterServer(s);

		}
		catch (RemoteException re) {
			System.out.println("Exception lendo atributos de uma setinha...");
		}

	}
	public void keyReleased(KeyEvent e) {
	}
	public void keyTyped(KeyEvent e) {
	}

	public Janela(ClientImpl cliente) {
		super("Setinhas");
		this.client = cliente;

		BorderLayout blayout = new BorderLayout(5, 5);

		Container c = getContentPane();

		c.setLayout(blayout);

		canvas = new Canvas();
		canvas.setSize(500, 500);
		float r = (float) 0.6;
		float g = (float) 0.6;
		float b = (float) 1.0;
		canvas.setBackground(new Color(r, g, b));
		c.add(canvas, BorderLayout.NORTH);

		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
			    try{
				client.exit();
			    }
			    catch(RemoteException r){}
			    System.exit(0);
			}
		});

		this.addKeyListener(this);
		c.addKeyListener(this);
		canvas.addKeyListener(this);

		setSize(400, 400);
		setLocation(100, 100);
		show();

	}

	/**
	 * Aqui tem de ficar esperto.
	 * Soh redesenha a setinha que a gente foi AVISADO
	 * porque se a gente redesenhar todas, a notificacao nao adianta de nada, ja que nao importa recebendo a notificacao ou nao, 
	 * a gente estaria pegando os dados mais recente.
	 */

	public void desenhaSeta(Graphics g, int x, int y, int angulo) {

		int x2, y2;

		float rad = (float) ((float) angulo * Math.PI) / 180;

		x2 = x + (int) (15 * Math.cos(rad));
		y2 = y - (int) (15 * Math.sin(rad));

		g.setColor(Color.yellow);
		g.drawLine(x, y, x2, y2);
		g.drawRect(x - 5, y - 5, 10, 10);
	}

	public synchronized void myPaint(Hashtable map) {
		Graphics g = canvas.getGraphics();
		try {
			g.clearRect(0, 0, 400, 400);
			
			Enumeration e = map.elements();
			while(e.hasMoreElements()){
				SetinhaCopia sc = (SetinhaCopia) e.nextElement();
				desenhaSeta(g, sc.x, sc.y, sc.angle);
			}
			
			SetinhaCopia ms = client.getMinhaSetinha();
			g.setColor(Color.red);
			g.drawRect(ms.x - 6, ms.y - 6, 12, 12);
			
		} 
		catch (Exception e) {
			System.out.println("Exception lendo atributos de uma setinha..." + e);
		}

	}

}
