import java.rmi.Remote;
import java.rmi.RemoteException;


/**
 * Interface do servidor principal. um servidor principal possui varios slaves, para que ele possa fazer o
 * load balacing de clientes.
 * 
 * 
 */
public interface MasterServer extends Remote {
	
	
	/**
	 * Quando um cliente quer se conectar ao jogo, ele pede ao servidor principal, que 
	 * passe a ele um servidor, e ele utilizara esse. O servidor faz um load balancing
	 * para decidir em que servidor ele jogara esse cliente.
	 *este metodo deve ser implementado como synchronized 
	 */
	SlaveServer getServer() throws RemoteException;
	
	/**
	 * Quando um Cliente mexe na setinha, ele pede para o servidor slave repassar esse aviso.
	 * O Slave, por sua vez, chama o master, por este metodo. Este metodo avisa TODOS os outros slaves (incluindo 
	 * o que chamou esse metodo) de que o cliente C teve mudancas.
	 *este metodo deve ser implementado como synchronized 
	 */
	void notifySlaveServers(Setinha s) 
	    throws RemoteException;
	
}




