import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Interface para a setinha do jogo.
 * Toda vez que 
 * Os metodos sao bem simples, todos getters e setters
 */
public interface Setinha extends Remote {
	/**
	 * Pega o ID da setinha
	 */
	String getId() throws RemoteException;



	/**
	 * Pega a posio X da setinha
	 */
	int getX() throws RemoteException;

	/**
	 * Pega a posio Y da setinha
	 */
	int getY() throws RemoteException;

	/**
	 * Pega o angulo da setinha
	 */
	int getAngle() throws RemoteException;

	/**
	 * Seta a posio X da setinha
	 */
	void setX(int x) throws RemoteException;

	/**
	 * Seta a posio Y da setinha
	 */
	void setY(int y) throws RemoteException;

	/**
	 * Seta o angulo da setinha
	 */
	void setAngle(int angle) throws RemoteException;
}

