import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.rmi.server.UnicastRemoteObject;


//import java.util.ArrayList;
//import java.util.Iterator;

import java.util.*;

/**
 * Implementacao do servidor slave
 * 
 */
public class SlaveServerImpl extends UnicastRemoteObject implements SlaveServer {
	
	protected String id, masterServerHost;
	protected MasterServer master;

	//protected ArrayList clients = new ArrayList();
	protected Vector clients = new Vector();

    private NumClientsLoadImpl load;
	
	/**
	 * Cria um slave, dado um id, e o ip do servidor principal
	 */
	public SlaveServerImpl(String id, String masterServerHost) throws RemoteException{
		this.id = id;
		this.masterServerHost = masterServerHost;
		load = new NumClientsLoadImpl();
	}
	
	public String getId() throws RemoteException {
		return id;
	}
	
	public synchronized Setinha newSetinha(Client c){ 
	    //throws RemoteException {
		try{
			clients.add(c);
			load.setIntLoad(load.getIntLoad() +1);
			SetinhaImpl setinha = new SetinhaImpl(c.getId());
			return setinha;
		}
		catch(Exception e){
			System.out.println("Nao foi possivel criar Setinha " + e);
		}
		return null;
	}
	
	
	public /*synchronized*/ void notifyClients(Setinha s) { 
	    //throws RemoteException{
		
		try{
			Iterator i = clients.iterator();
			while (i.hasNext()) {
				Client cc = (Client) i.next();
				try {
					cc.avisa(s);
				}
				catch (RemoteException re) {
					System.out.println("Um dos clientes nao esta respondendo..." + re);
					//clients.remove(cc);
				}
			}	
		}
		catch(Exception e){
			System.out.println("Erro notificando clientes:" + e);
		}	
	}
	
	
	public Load getLoad() {
		return load;	
	}
	
	public synchronized void notifyMasterServer(Setinha s){ 
	    //throws RemoteException {
		
		try{
			if (master == null) {
					try {
						master = (MasterServer) Naming.lookup("//"+masterServerHost+"/MasterServer");
					} catch (MalformedURLException e) {
					} catch (RemoteException e) {
					} catch (NotBoundException e) {
					}	
			}
			master.notifySlaveServers(s);
		}
		catch(Exception e){
			System.out.println("Erro notificando MasterServer " + e);
		}
	}

    public void disconnect(Client c){
		clients.remove(c);
    }
	
	
	public static void main(String args[]) throws MalformedURLException, RemoteException, RemoteException {
	
		// Create and install a security manager
		if (System.getSecurityManager() == null) {
			System.setSecurityManager(new RMISecurityManager());
		}

		
		SlaveServerImpl server = new SlaveServerImpl(args[0], args[1]);
		Naming.rebind("//localhost/SlaveServer" + server.getId(), server);		
		System.out.println("Slave server criado.");
		
	
	
	}

}
